#!/usr/bin/env python
import sys
sys.path.append('../modules')
import aiml

import os
import xml.parsers.expat

class botpredparser:
	__bot_predicates = {}
	__tag_cache = []
	def __init__(self):
		pass
	def start_element(self, name, attrs):
		if len(self.__tag_cache) > 1:
			raise SyntaxError
		self.__tag_cache.append([name, attrs])
		if name == "bot" and not attrs.has_key("name"):
			raise SyntaxError
	def end_element(self, name):
		elem = self.__tag_cache.pop()
		if elem[0] != name:
			raise SyntaxError
	def char_data(self, data):
		if self.__tag_cache[len(self.__tag_cache)-1][0] == "bot":
			self.__bot_predicates[self.__tag_cache[len(self.__tag_cache)-1][1]['name']] = data

	def parse(self, filename):
		if not os.path.isfile(filename):
			raise IOError
	
		self.__bot_predicates = {}
		p = xml.parsers.expat.ParserCreate()

		p.StartElementHandler = self.start_element
		p.EndElementHandler = self.end_element
		p.CharacterDataHandler = self.char_data

		predfile = file(filename)
		p.Parse(predfile.read(), 1)
		predfile.close()
		return self.__bot_predicates


if not sys.argv[1:]:
	print "usage %s <name>" % sys.argv[0]
	sys.exit(0)

_aimlname = sys.argv[1]

k = aiml.Kernel()

k.learn(_aimlname + '-startup.xml')

bpp = botpredparser()
__bot_predicates = bpp.parse("../../ai_plugin.bot_predicates.xml")
for name,value in __bot_predicates.items():
	k.setBotPredicate(name, value)

k.loadSubs("../../ai_plugin.substfile.conf")

k.verbose()
k.respond("load aiml " + _aimlname)

while True: print k.respond(raw_input("> "))

