##
## jabberif helper classes
##
##	written by Ben Fuhrmannek <bef@erlangen.ccc.de>
##

import re
from string import join

class message:
	"""this message class contains one message"""
	
	def __init__(self, type, handler, origin, message, args={}):
		## type of message like jabber or raw
		self.__type = type
		## origin as string representation
		self.__origin = origin
		## handler is an input plugin instance
		self.__handler = handler
		## message as string representation
		self.__message = message
		## handler specific args
		self.__args = args
	
	def get(self):
		return self.__message
	
	def get_from(self):
		return self.__origin
	
	def get_type(self):
		return self.__type
	
	def get_args(self):
		return self.__args
	
	def get_handler(self):
		return self.__handler
	
	def get_uid(self):
		return self.__type + ':' + self.__origin
	
	def send_back(self, message):
		"""send message back to sender"""
		self.__handler.ph.log('[' + self.get_uid() + '] ' + join(re.split('\r?\n', message), '\n\t'), 'outmessage')
		self.__handler._send_back(self, message)
	
