##
## jabberif google plugin
##	search in google using the google soap api
##
##	written by Ben Fuhrmannek <bef@erlangen.ccc.de>
##

from baseclasses import output_plugin
import sys
from string import join,strip
import SOAPpy

class google_plugin(output_plugin):
	def __init__(self, ph):
		self.ph = ph
		self._name = 'google_plugin'
		self._desc = 'google search'

		self.__default_config = { 'google_key':'' }
		self._configure()
		
		## init soap proxy
		self.__server = SOAPpy.SOAPProxy('http://api.google.com/search/beta2', namespace='urn:GoogleSearch')

	
	def _configure(self):
		self.__config = self.ph.get_plugin_config(self, self.__default_config)
		self.__key = self.__config['google_key']
	
	def _on_load(self):
		self.ph._register_command(self, 'google', self.googlesearch, '[keywords] search in google')
	
	
	####################################################################################################
	## search functions
	
	def __search(self, searchstring, maxresults = 5):
		google_key = self.__key
		soapfalse = SOAPpy.booleanType(0)
		data = self.__server.doGoogleSearch( google_key, searchstring, 0, maxresults, soapfalse, '', soapfalse, '', '', '')
		return [node._asdict() for node in data.resultElements]
		
	def googlesearch(self, args):
		wholemsg = strip(args['msg'].get())
		search = wholemsg[wholemsg.find(' ')+1:]

		result = self.__search(search)
		outputs = [r['title']+'\n'+r['URL'] for r in result]
		output = join(outputs, '\n\n')
		if output == '':
			output = 'not result'
		args['msg'].send_back('\n'+output)

