##
## jabberif template plugin
##	example plugin.
##
##	written by Ben Fuhrmannek <bef@erlangen.ccc.de>
##
##

from baseclasses import output_plugin
from helpers import message
import time


class template_plugin(output_plugin):
	def __init__(self, ph):
		## requierd variables
		self.ph = ph				## the pluginhandler instance
		self._name = 'template_plugin'		## plugin name
		self._desc = 'do nothing'		## short description

		## default configuration
		##	consisting of name/value pairs where the value is the default value
		##
		##	these options can be configured in the [template_plugin] section of
		##	the configuration file
		self.__default_config = {	'whatever':'5',
						'answer':'42' }
		self._configure()

		## init stuff
		## ...
		self.__init_template()
		
	
	def _configure(self):
		self.__config = self.ph.get_plugin_config(self, self.__default_config)
		self.__answer = int(self.__config['answer']) * int(self.__config['whatever'])
	
	def _on_load(self):
		self.ph._register_command(self, 'test', self.templatetest, 'test', {'longhelp':'this is a very long description....'})
		self.ph._register_command(self, 'restrictedtest', self.templatetest, 'test', {'level':5})
		
	def _on_unload(self):
		## do some cleanup...
		pass
		
	####################################################################################################
	## init
	
	def __init_template(self):
		## initialize things...
		self.__secret_message = 23


	####################################################################################################
	## command functions
		
	def templatetest(self, args):
		self_command_name = args['cmd'][0]
		command_line_args = args['cmd'][1:]
		user_id = args['msg'].get_uid()
		user_level = self.ph.get_userlevel(user_id)

		## process sth.....
		answer = self.__answer
		if user_level < 50:
			answer = self.__secret_message

		args['msg'].send_back("secret test with params '%s' and the answer is %d" % (str(command_line_args), answer))

